apiVersion: apiextensions.crossplane.io/v1
kind: CompositeResourceDefinition
metadata:
  name: compositenetworks.multik8s.platformref.crossplane.io
  namespace: crossplane
  annotations:
    upbound.io/ui-schema: |-
      ---
      configSections:
      - title: Network Info
        description: Information about this network fabric
        items:
        - name: id
          controlType: singleInput
          type: string
          path: ".spec.id"
          title: Network ID
          description: Network ID that other objects will use to refer (and connect) to this network fabric
          default: multik8s-network
          validation:
          - required: true
            customError: Network ID is required.
        - name: region
          controlType: singleInput
          type: string
          path: ".spec.region"
          title: Region
          description: Region that other objects will use to refer (and connect) to this network fabric
          default: europe-west9
          validation:
          - required: true
            customError: Region is required.
        - name: provider
          controlType: singleSelect
          path: ".spec.compositionSelector.matchLabels[provider]"
          title: Cloud Provider
          description: Select which cloud provider this network should be created in.
          default: AWS
          enum:
          - AWS
          - GCP
          validation:
          - required: true
            customError: Cloud provider is required.
      - title: Cluster Info
        description: The cluster used with this network fabric
        items:
        - name: clusterRef
          controlType: singleInput
          type: string
          path: ".spec.clusterRef.id"
          title: Cluster Ref
          description: ID of the Cluster object that will use this network fabric
          default: multik8s-cluster
          validation:
          - required: true
            customError: Cluster ref is required.
spec:
  claimNames:
    kind: Network
    plural: networks
  group: multik8s.platformref.crossplane.io
  names:
    kind: CompositeNetwork
    plural: compositenetworks
  versions:
    - name: v1alpha1
      served: true
      referenceable: true
      schema:
        openAPIV3Schema:
          type: object
          properties:
            spec:
              type: object
              properties:
                id:
                  type: string
                  description: ID of this Network that other objects will use to refer to it.
                region:  
                  type: string
                  description: The cluster region
                clusterRef:
                  type: object
                  description: "A reference to the Cluster object that this network will be used for."
                  properties:
                    id:
                      type: string
                      description: ID of the Cluster object this ref points to.
                  required:
                    - id
              required:
                - id
                - region
                - clusterRef